# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Generate distribution booleans
%global rhl9	%(if [ "%{__distinit}%{__distvers}" == "rhl9"	]; then echo 1; else echo 0; fi)
%global rhel3	%(if [ "%{__distinit}%{__distvers}" == "rhel3"	]; then echo 1; else echo 0; fi)
%global rhel4	%(if [ "%{__distinit}%{__distvers}" == "rhel4"	]; then echo 1; else echo 0; fi)
%global rhel5	%(if [ "%{__distinit}%{__distvers}" == "rhel5"	]; then echo 1; else echo 0; fi)
%global rhel6	%(if [ "%{__distinit}%{__distvers}" == "rhel6"	]; then echo 1; else echo 0; fi)
%global fc1	%(if [ "%{__distinit}%{__distvers}" == "fc1"	]; then echo 1; else echo 0; fi)
%global fc2	%(if [ "%{__distinit}%{__distvers}" == "fc2"	]; then echo 1; else echo 0; fi)
%global fc3	%(if [ "%{__distinit}%{__distvers}" == "fc3"	]; then echo 1; else echo 0; fi)
%global fc4	%(if [ "%{__distinit}%{__distvers}" == "fc4"	]; then echo 1; else echo 0; fi)
%global fc5	%(if [ "%{__distinit}%{__distvers}" == "fc5"	]; then echo 1; else echo 0; fi)
%global fc6	%(if [ "%{__distinit}%{__distvers}" == "fc6"	]; then echo 1; else echo 0; fi)
%global fc7	%(if [ "%{__distinit}%{__distvers}" == "fc7"	]; then echo 1; else echo 0; fi)
%global fc8	%(if [ "%{__distinit}%{__distvers}" == "fc8"	]; then echo 1; else echo 0; fi)
%global fc9	%(if [ "%{__distinit}%{__distvers}" == "fc9"	]; then echo 1; else echo 0; fi)
%global fc10	%(if [ "%{__distinit}%{__distvers}" == "fc10"	]; then echo 1; else echo 0; fi)
%global fc11	%(if [ "%{__distinit}%{__distvers}" == "fc11"	]; then echo 1; else echo 0; fi)
%global fc12	%(if [ "%{__distinit}%{__distvers}" == "fc12"	]; then echo 1; else echo 0; fi)
%global fc13	%(if [ "%{__distinit}%{__distvers}" == "fc13"	]; then echo 1; else echo 0; fi)
%global fc14	%(if [ "%{__distinit}%{__distvers}" == "fc14"	]; then echo 1; else echo 0; fi)
%global fc15	%(if [ "%{__distinit}%{__distvers}" == "fc15"	]; then echo 1; else echo 0; fi)
%global fc16	%(if [ "%{__distinit}%{__distvers}" == "fc16"	]; then echo 1; else echo 0; fi)
%global fc17	%(if [ "%{__distinit}%{__distvers}" == "fc17"	]; then echo 1; else echo 0; fi)
%global fc18	%(if [ "%{__distinit}%{__distvers}" == "fc18"	]; then echo 1; else echo 0; fi)
%global fc19	%(if [ "%{__distinit}%{__distvers}" == "fc19"	]; then echo 1; else echo 0; fi)
%global fc20	%(if [ "%{__distinit}%{__distvers}" == "fc20"	]; then echo 1; else echo 0; fi)

# Check for a supported platform
%if ! %{rhl9} && ! %{rhel3} && ! %{rhel4} && ! %{rhel5} && ! %{rhel6} && ! %{fc1} && ! %{fc2} && ! %{fc3} && ! %{fc4} && ! %{fc5} && ! %{fc6} && ! %{fc7} && ! %{fc8} && ! %{fc9} && ! %{fc10} && ! %{fc11} && ! %{fc12} && ! %{fc13} && ! %{fc14} && ! %{fc15} && ! %{fc16} && ! %{fc17} && ! %{fc18} && ! %{fc19} && ! %{fc20}
%{error: Unsupported platform %{__distinit}%{__distvers} - please tweak the spec file accordingly}
%endif

# Old distros don't have a new enough pygtk2 for the GUI
%define nogui %{rhl9} || %{rhel3} || %{rhel4} || %{fc1} || %{fc2} || %{fc3}

# If directory /run/lock exists, do a systemd-based build; otherwise,a sysvinit-based build
%global use_systemd %([ -d /run/lock ] && echo 1 || echo 0)

# A few useful macros
%global python_version %(python -c "import sys; print sys.version[:3]" 2>/dev/null)
%{!?python_sitelib: %global python_sitelib %{_prefix}/lib/python%{python_version}/site-packages}
%global desktopvendor	city-fan.org
%global bt_dir		%{_localstatedir}/lib/bittorrent
%global bt_datadir	%{bt_dir}/data
%global bt_statedir	%{bt_dir}/state

# FC ≥ 4 and RHEL ≥ 5 have /etc/pki
%if %{rhl9} || %{fc1} || %{fc2} || %{fc3} || %{rhel3} || %{rhel4}
%global pkidir %{_datadir}
%else
%global pkidir %{_sysconfdir}/pki
%endif

Summary:	BitTorrent swarming network file transfer tool
Name:		bittorrent
Version:	4.4.0
Release:	16.0.cf.%{__distinit}%{__distvers}
Group:		Applications/Internet
License:	BitTorrent
URL:		http://www.bittorrent.com/
Source0:	http://download.bittorrent.com/dl/archive/BitTorrent-%{version}.tar.gz
Source1:	bittorrent.desktop
Source3:	btseed.init
Source4:	bttrack.init
Source5:	bittorrent.png
Source6:	bittorrent-4.4.0-readme.fedora
Patch0:		bittorrent-4.2.2-no-version-check.patch
Patch1:		bittorrent-4.4.0-appdir.patch
Patch2:		bittorrent-4.4.0-pkidir.patch
Patch3:		bittorrent-4.4.0-shellbang.patch
Patch4:		bittorrent-4.4.0-threads-warning.patch
Patch5:		bittorrent-4.4.0-fastresume.patch
Patch6:		bittorrent-4.4.0-syntax.patch
Patch7:		bittorrent-4.4.0-formatstrings.patch
Patch8:		bittorrent-4.4.0-bencode-float.patch
Patch9:		bittorrent-4.4.0-keyerror.patch
Patch10:	bittorrent-4.3.5-py2.2-compat.patch
Patch11:	bittorrent-4.4.0-hashlib.patch
Patch12:	bittorrent-4.4.0-readme-systemd.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	python2-devel >= 2.2.1, desktop-file-utils, gettext
%if %{use_systemd}
BuildRequires:	systemd-units
%endif
Requires:	python-crypto
# Python dependencies keep changing
%if "%{python_version}" == "2.2"
Requires:	python >= 2.2.1
%endif
%if "%{python_version}" == "2.3"
Requires:	python-abi = 2.3
%endif

Provides:	python-khashmir = %{version}-%{release}
Obsoletes:	python-khashmir < %{version}-%{release}
%if %{nogui}
Obsoletes:	BitTorrent < %{version}-%{release}, bittorrent-gui < %{version}-%{release}
Provides:	BitTorrent = %{version}-%{release}, bittorrent-gui < %{version}-%{release}
%endif

Requires(pre): /usr/bin/getent /usr/sbin/groupadd /usr/sbin/useradd /usr/sbin/usermod
%if %{use_systemd}
Requires(post):	systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
%else
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
%endif

%description
BitTorrent is a tool for distributing files. It's extremely easy to use -
downloads are started by clicking on hyperlinks. Whenever more than one person
is downloading at once they send pieces of the file(s) to each other, thus
relieving the central server's bandwidth burden. Even with many simultaneous
downloads, the upload burden on the central server remains quite small, since
each new downloader introduces new upload capacity.

%if ! %{nogui}
%package gui
Summary:	GUI versions of the BitTorrent file transfer tools
Group:		Applications/Internet
Requires:	pygtk2 >= 2.6.0
Requires:	%{name} = %{version}-%{release}
Obsoletes:	BitTorrent < %{version}-%{release}, BitTorrent-gui < %{version}-%{release}
Provides:	BitTorrent = %{version}-%{release}, BitTorrent-gui = %{version}-%{release}

Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils

%description gui
BitTorrent is a tool for distributing files. It's extremely easy to use -
downloads are started by clicking on hyperlinks. Whenever more than one person
is downloading at once they send pieces of the file(s) to each other, thus
relieving the central server's bandwidth burden. Even with many simultaneous
downloads, the upload burden on the central server remains quite small, since
each new downloader introduces new upload capacity.

This package contains the graphical versions of the BitTorrent tools.
%endif

%prep
%setup -q -n BitTorrent-%{version}

# FC2 and older must use "su" instead of "runuser"
%if %{rhl9} || %{fc1} || %{fc2} || %{rhel3}
cp -p %{SOURCE1} %{SOURCE5} .
sed 's@/sbin/runuser @/bin/su @' %{SOURCE3} > btseed.init
sed 's@/sbin/runuser @/bin/su @' %{SOURCE4} > bttrack.init
%else
cp -p %{SOURCE1} %{SOURCE3} %{SOURCE4} %{SOURCE5} .
%endif

cp -p %{SOURCE6} README.Fedora

# Fix for python 2.2
%patch10 -p1 -b .python22

# Don't use unsupported command options
%if %{rhl9} || %{rhel3}
sed -i "s/--no-fuzzy-matching //" makei18n.sh
%endif

# Prevent phone-home new version check
%patch0 -p1 -b .versioncheck

# Our package is "bittorrent", not "BitTorrent"
%patch1 -p1 -b .packagename

# Put public key in standard place
%patch2 -p1 -b .keydir
sed -i -e 's,@@PKIDIR@@,%{pkidir},' BitTorrent/NewVersion.py

# Remove useless shellbangs
%patch3 -p1 -b .shellbang

# Fix some deprecation warnings from pygtk2
%patch4 -p1 -b .thread-warnings

# Write fastresume data properly so that it's recognized at next startup
%patch5 -p1 -b .fastresume

# Fix syntax error on python 2.6
%patch6 -p1 -b .syntax

# Fix format strings that can't be properly translated
# Not much point doing this really as translations don't work anyway and
# it doesn't prevent the build itself from working
%if 0
%patch7 -p1 -b .strings
%endif

# Add bencode support for floating point values (#451496)
%patch8 -p1 -b .float

# Fix keyerror on tracker (#451496)
%patch9 -p1 -b .keyerror

# Fix deprecation warnings from use of sha module
%patch11 -p1 -b .sha

# Tweak README.Fedora to reflect systemd usage
%if %{use_systemd}
%patch12 -p0 -b .systemd
%endif

# Update icon
sed -i -e 's,bittorrent\.png,%{_datadir}/pixmaps/bittorrent-%{version}/logo/bittorrent_48.png,' \
	bittorrent.desktop

# Create options files for initscripts
cat <<EOF >bittorrent.sysconfig
SEEDDIR=%{bt_datadir}
SEEDOPTS="--max_upload_rate 350 --display_interval 300"
SEEDLOG=%{_localstatedir}/log/bittorrent/btseed.log
TRACKPORT=6969
TRACKDIR=%{bt_datadir}
TRACKSTATEFILE=%{bt_statedir}/bttrack
TRACKLOG=%{_localstatedir}/log/bittorrent/bttrack.log
TRACKOPTS="--min_time_between_log_flushes 4.0 --show_names 1 --hupmonitor 1"
EOF

# Unit files for systemd
cat <<'EOF' >btseed.service
[Unit]
Description = Seed client for BitTorrent

[Service]
Type = simple
Environment = SEEDDIR=%{bt_datadir}
Environment = SEEDLOG=%{_localstatedir}/log/bittorrent/seed-client.log
Environment = SEEDOPTS="--max_upload_rate 350 --display_interval 300"
EnvironmentFile = -/etc/sysconfig/bittorrent
User = torrent
Group = torrent
# Hack using sh because StandardOutput= doesn't offer an "append to file" option
ExecStart = /bin/sh -c "/usr/bin/launchmany-console $SEEDOPTS $SEEDDIR >>$SEEDLOG 2>&1"

[Install]
WantedBy = multi-user.target
EOF

cat <<'EOF' >bttrack.service
[Unit]
Description = BitTorrent Tracker

[Service]
Type = simple
Environment = TRACKDIR=%{bt_datadir}
Environment = TRACKPORT=6969
Environment = TRACKSTATEFILE=%{bt_statedir}/tracker
Environment = TRACKOPTS=
Environment = TRACKLOG=%{_localstatedir}/log/bittorrent/tracker.log
EnvironmentFile = -/etc/sysconfig/bittorrent
User = torrent
Group = torrent
ExecStart = /usr/bin/bittorrent-tracker --port $TRACKPORT --dfile $TRACKSTATEFILE --logfile $TRACKLOG $TRACKOPTS --allowed_dir $TRACKDIR
StandardOutput = null
StandardError = null

[Install]
WantedBy = multi-user.target
EOF

# Have the services' log files rotated
cat <<EOF >bittorrent.logrotate
%{_localstatedir}/log/bittorrent/btseed.log %{_localstatedir}/log/bittorrent/seed-client.log {
	notifempty
	missingok
	postrotate
%if %{use_systemd}
		/bin/systemctl try-restart bittorrent-seed-client.service 2>/dev/null >/dev/null || :
%else
		/sbin/service btseed condrestart 2>/dev/null >/dev/null || :
%endif
	endscript
}

%{_localstatedir}/log/bittorrent/bttrack.log %{_localstatedir}/log/bittorrent/tracker.log {
	notifempty
	missingok
	postrotate
%if %{use_systemd}
		/bin/systemctl try-restart bittorrent-tracker.service 2>/dev/null >/dev/null || :
%else
		/sbin/service bttrack condrestart 2>/dev/null >/dev/null || :
%endif
	endscript
}
EOF

%build
python setup.py build

%install
rm -rf %{buildroot}
python setup.py install -O1 --skip-build --root %{buildroot}
install -d -m 755 %{buildroot}%{_datadir}/applications
install -d -m 755 %{buildroot}%{pkidir}/bittorrent
install -m 0644 public.key %{buildroot}%{pkidir}/bittorrent
desktop-file-install \
	--vendor %{desktopvendor} \
	--dir %{buildroot}%{_datadir}/applications \
	bittorrent.desktop
install -d %{buildroot}%{bt_dir}
install -d %{buildroot}%{bt_datadir}
install -d %{buildroot}%{bt_statedir}
install -d %{buildroot}%{_localstatedir}/{run,log/bittorrent}
%if %{use_systemd}
install -m 0644 -D btseed.service %{buildroot}%{_unitdir}/bittorrent-seed-client.service
install -m 0644 -D bttrack.service %{buildroot}%{_unitdir}/bittorrent-tracker.service
%else
install -m 0755 -D btseed.init %{buildroot}%{_initrddir}/btseed
install -m 0755 -D bttrack.init %{buildroot}%{_initrddir}/bttrack
# pidof doesn't find scripts with hyphenated names, so make some convenience links for initscripts
ln -s bittorrent-tracker %{buildroot}%{_bindir}/bttrack
ln -s launchmany-console %{buildroot}%{_bindir}/btseed
%endif
install -m 0644 -D bittorrent.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/bittorrent
install -m 0644 -D bittorrent.logrotate %{buildroot}%{_sysconfdir}/logrotate.d/bittorrent
install -m 0644 -D bittorrent.png \
	%{buildroot}%{_datadir}/pixmaps/bittorrent-%{version}/logo/bittorrent_48.png
# add symlink for bittorrent.png required by desktop entry
ln -s bittorrent-%{version}/logo/bittorrent_48.png %{buildroot}%{_datadir}/pixmaps/bittorrent.png
%{find_lang} bittorrent
# include egg-info if present
if [ -f %{buildroot}%{python_sitelib}/BitTorrent-%{version}-*.egg-info ]; then
	echo %{buildroot}%{python_sitelib}/BitTorrent-%{version}-*.egg-info |
		sed -e 's|^%{buildroot}||'
fi >> bittorrent.lang

%clean
rm -rf %{buildroot}

%pre
getent group torrent >/dev/null || groupadd -r torrent
getent passwd torrent >/dev/null || \
	useradd -r -s /sbin/nologin -d %{bt_dir} -g torrent \
		-c "BitTorrent Seed/Tracker" torrent
# Fix homedir for upgrades
usermod --home %{bt_dir} torrent &>/dev/null
exit 0

%post
if [ $1 -eq 1 ]; then
	# Initial installation
%if %{use_systemd}
	/bin/systemctl daemon-reload &>/dev/null || :
%else
	/sbin/chkconfig --add btseed  || :
	/sbin/chkconfig --add bttrack || :
%endif
fi

%preun
if [ $1 -eq 0 ]; then
	# Package removal, not upgrade
%if %{use_systemd}
	/bin/systemctl --no-reload disable bittorrent-seed-client.service &>/dev/null || :
	/bin/systemctl --no-reload disable bittorrent-tracker.service &>/dev/null || :
	/bin/systemctl stop bittorrent-seed-client.service &>/dev/null || :
	/bin/systemctl stop bittorrent-tracker.service &>/dev/null || :
%else
	%{_initrddir}/btseed  stop &>/dev/null || :
	%{_initrddir}/bttrack stop &>/dev/null || :
	/sbin/chkconfig --del btseed  || :
	/sbin/chkconfig --del bttrack || :
%endif
fi

%postun
%if %{use_systemd}
/bin/systemctl daemon-reload &>/dev/null || :
%endif
if [ $1 -gt 0 ]; then
	# Package upgrade, not uninstall
%if %{use_systemd}
	/bin/systemctl try-restart bittorrent-seed-client.service &>/dev/null || :
	/bin/systemctl try-restart bittorrent-tracker.service &>/dev/null || :
%else
	%{_initrddir}/btseed  condrestart &>/dev/null || :
	%{_initrddir}/bttrack condrestart &>/dev/null || :
%endif
fi

%if ! %{nogui}
%post gui
update-desktop-database %{_datadir}/applications &>/dev/null || :

%postun gui
update-desktop-database %{_datadir}/applications &>/dev/null || :
%endif

%files -f bittorrent.lang
%defattr(-,root,root,-)
%doc README.txt credits.txt credits-l10n.txt LICENSE.txt TRACKERLESS.txt
%doc README.Fedora
%{_bindir}/bittorrent-console
%{_bindir}/bittorrent-curses
%{_bindir}/bittorrent-tracker
%{_bindir}/changetracker-console
%{_bindir}/launchmany-console
%{_bindir}/launchmany-curses
%{_bindir}/maketorrent-console
%{_bindir}/torrentinfo-console
%if ! %{use_systemd}
%{_bindir}/bttrack
%{_bindir}/btseed
%endif
%{pkidir}/bittorrent
%dir %{python_sitelib}/BitTorrent/
%{python_sitelib}/BitTorrent/*.py*
%{python_sitelib}/khashmir/
%attr(-,torrent,torrent) %dir %{bt_dir}/
%attr(-,torrent,torrent) %dir %{bt_datadir}/
%attr(-,torrent,torrent) %dir %{bt_statedir}/
%attr(-,torrent,torrent) %dir %{_localstatedir}/log/bittorrent/
%if %{use_systemd}
%{_unitdir}/bittorrent-seed-client.service
%{_unitdir}/bittorrent-tracker.service
%else
%{_initrddir}/btseed
%{_initrddir}/bttrack
%endif
%config(noreplace) %{_sysconfdir}/logrotate.d/bittorrent
%config(noreplace) %{_sysconfdir}/sysconfig/bittorrent
%if %{nogui}
%exclude %{_bindir}/bittorrent
%exclude %{_bindir}/maketorrent
%exclude %{_datadir}/pixmaps/bittorrent-%{version}/
%exclude %{_datadir}/applications/%{desktopvendor}-bittorrent.desktop
%else
%files gui
%defattr(-,root,root,-)
%{_bindir}/bittorrent
%{_bindir}/maketorrent
%{_datadir}/pixmaps/bittorrent.png
%{_datadir}/pixmaps/bittorrent-%{version}/
%{_datadir}/applications/%{desktopvendor}-bittorrent.desktop
%endif

%changelog
* Tue Oct 18 2011 Paul Howarth <paul@city-fan.org> 4.4.0-16.0.cf
- Use native systemd init from Fedora 15 onwards
- Add build support for Fedora 17..20
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Jul 28 2010 Paul Howarth <paul@city-fan.org> 4.4.0-15.0.cf
- Rebuilt for https://fedoraproject.org/wiki/Features/Python_2.7/MassRebuild

* Thu May 27 2010 Paul Howarth <paul@city-fan.org> 4.4.0-14.0.cf
- Fix dist tag for RHEL-6 Beta and support up to Fedora 16
- Source is now in an "archive" directory

* Thu Feb 25 2010 Paul Howarth <paul@city-fan.org> 4.4.0-13.0.cf
- Fix deprecation warnings by using hashlib instead of sha when possible
- Update fastresume patch for additional fix
- Fix dist tags for current Rawhide and support up to Fedora 15

* Fri Apr 24 2009 Paul Howarth <paul@city-fan.org> 4.4.0-12.0.cf
- Add icon back in menu entry

* Mon Apr  6 2009 Paul Howarth <paul@city-fan.org> 4.4.0-11.0.cf
- Add support for floating point values in bencode (#451496), resolving
  tracebacks with KeyError: <type 'float'>
  (thanks to Oleg Aprotskiy for the patch)
- Don't apply format string patch; it serves no purpose really
- Fix for KeyError: 'max_incomplete' in tracker (#451496)
- Update to SLES-compatible dist tag macros
- Define RPM macros in global context in spec file

* Tue Feb 24 2009 Paul Howarth <paul@city-fan.org> 4.4.0-10.0.cf
- Add build support for Fedora 11
- Fix syntax issues causing failure to build for Fedora 11
- Update format strings to enable re-ordering of parameters in translations
- Add additional categories FileTransfer and P2P in desktop entry (#487789)

* Fri Aug 15 2008 Paul Howarth <paul@city-fan.org> 4.4.0-7.0.CF
- Add build support for Fedora 10
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Use new scriptlets for user/group creation
- Fix up torrent homedir silently (#457563)
- Create a pidfile for btseed (#458926)
- Remove tracker pidfile when service is stopped (no need to include the
  %%ghost-ed pidfile now)
- Use %%{_initrddir} instead of %%{_sysconfdir}/rc.d/init.d
- Call initscripts directly instead of via /sbin/service to reduce scriptlet
  dependencies

* Thu Apr 10 2008 Paul Howarth <paul@city-fan.org> 4.4.0-6.0.CF
- Resync with Fedora release 4.4.0-6
- Add build support for Fedora 6-9 and RHEL 5
- Default data directory moved back out of /srv
  (to %%{_localstatedir}/lib/bittorrent)
  (http://fedoraproject.org/wiki/PackagingDrafts/NoBitsInSrv)
- Change torrent user's home directory from %%{_localstatedir}/spool/bittorrent
  to %%{_localstatedir}/lib/bittorrent, fix the home directory of any existing
  torrent user, and don't include %%{_localstatedir}/spool/bittorrent in the
  package any more
- Include egg-info if present (#440906)
- Fix some deprecation warnings from pygtk2
- Add README.Fedora to explain how to use the track/seed services (#430849)
- Use short license name to pacify rpmlint
- Don't %%ghost .pyo files
- Use patches rather than scripted edits to detect changes more easily
- Have a separate source file for the desktop file instead of using a here
  document in the spec file
- StartupNotify=true in desktop file
- Don't use categories X-Fedora or Application in the desktop file
- Use new icon for menu; icon cache scriptlets no longer needed
- Source is now on download.bittorrent.com, not www.bittorrent.com
- GUI subpackage provides BitTorrent-gui as well as obsoleting it
- Convert spec file to UTF-8

* Tue Mar 21 2006 Paul Howarth <paul@city-fan.org> 4.4.0-2
- Add Fedora Core 5 suuport

* Thu Feb  2 2006 Paul Howarth <paul@city-fan.org> 4.4.0-1
- Update to 4.4.0
- Tweak distribution-detection code to support builds on CentOS etc.

* Tue Jan 24 2006 Paul Howarth <paul@city-fan.org> 4.3.6-1
- Update to 4.3.6

* Tue Jan 10 2006 Paul Howarth <paul@city-fan.org> 4.3.5-1
- Update to 4.3.5
- Specify explicit path for su or runuser in initscripts
- Add patch to fix python-2.2 compatibility breakage
- Merge /etc/sysconfig/{btseed,bttrack} into /etc/sysconfig/bittorrent
- Merge /etc/logrotate.d/{btseed,bttrack} into /etc/logrotate.d/bittorrent
- Fix initscript for bttrack to allow for pidfile creation
- Ghost /var/run/bittorrent-tracker.pid so it gets deleted on package removal
- Add comments in %%prep
- Remove shebangs from python files to reduce rpmlint output

* Sat Dec 31 2005 Paul Howarth <paul@city-fan.org> 4.3.4-1
- Update to 4.3.4

* Tue Dec 20 2005 Paul Howarth <paul@city-fan.org> 4.3.3-2
- Add patch to prevent phoning home for new version checks

* Mon Dec 19 2005 Paul Howarth <paul@city-fan.org> 4.3.3-1
- Update to 4.3.3

* Tue Dec 13 2005 Paul Howarth <paul@city-fan.org> 4.3.2-1
- Update to 4.3.2
- Don't use the standard python_sitelib idiom - it's broken on RHEL3 x86_64 and
  puts noarch data into arch-specific directory

* Tue Dec  6 2005 Paul Howarth <paul@city-fan.org> 4.3.1-1
- Update to 4.3.1
- GUI now requires pygtk2 >= 2.6.0, so we no longer build the GUI for Red Hat
  Enterprise Linux 4 or Fedora Core 3

* Tue Dec  6 2005 Paul Howarth <paul@city-fan.org> 4.2.1-1
- Update to 4.2.1
- Source now at www.bittorrent.com rather than sourceforge

* Wed Nov 23 2005 Paul Howarth <paul@city-fan.org> 4.2.0-1
- Update to 4.2.0

* Wed Nov 16 2005 Paul Howarth <paul@city-fan.org> 4.1.8-1
- Update to 4.1.8

* Thu Nov  3 2005 Paul Howarth <paul@city-fan.org> 4.1.7-1
- Update to 4.1.7

* Fri Oct 28 2005 Paul Howarth <paul@city-fan.org> 4.1.6-3
- Current CodeVille checkout
- Simplify distribution-detection, not querying rpmdb at build time
- Unconditionally remove buildroot in %%install and %%clean

* Tue Oct 18 2005 Paul Howarth <paul@city-fan.org> 4.1.6-2
- Use CodeVille checkout from upstream that fixes python-2.2.x issues
- Don't use pathname macros for build-time commands - hardcode them instead

* Wed Oct 12 2005 Paul Howarth <paul@city-fan.org> 4.1.6-1
- Update to 4.1.6
- Use "su" rather than "runuser" in initscripts for FC2 and older
- Update python-2.2 compatibility patch to get us closer to working
- Append to seed log rather than overwrite it

* Mon Sep 19 2005 Paul Howarth <paul@city-fan.org> 4.1.4-2
- Add beginnings of support for legacy distributions Red Hat Linux 9, Red Hat
  Enterprise Linux 3, and Fedora Core 1 (without GUI support of course). Not
  working at the moment because the trackerless client code uses heapq, which
  is not available in python 2.2.x.

* Wed Aug 17 2005 Paul Howarth <paul@city-fan.org> 4.1.4-1
- Update to 4.1.4
- All "binaries" renamed; initscripts & desktop entry changed accordingly
- Don't need to edit out "env python2"... stuff
- "appdir" now set in platform.py instead of __init__.py
- Add credits-l10n.txt as %%doc
- Add python-crypto dependency
- Add public.key in appropriate place

* Fri Jul 15 2005 Paul Howarth <paul@city-fan.org> 4.1.3-1
- Update to 4.1.3

* Fri Jul 15 2005 Paul Howarth <paul@city-fan.org> 4.1.2-5
- Provides: should be version-release tagged too

* Tue Jul 12 2005 Paul Howarth <paul@city-fan.org> 4.1.2-4
- Use 48x48 icon
- Move icon to %%{_datadir}/icons/hicolor/48x48/apps instead of
  %%{_datadir}/pixmaps and update icon cache on installation if
  necessary (#162465)

* Mon Jul 11 2005 Paul Howarth <paul@city-fan.org> 4.1.2-3
- Support builds on FC2, without -gui subpackage
- Tweak obsoletes for cleaner upgrades
- Enable startup notification in desktop entry

* Mon Jul  4 2005 Paul Howarth <paul@city-fan.org> 4.1.2-2
- Add Provides/Obsoletes for python-khashmir for clean upgrades from split
  bittorrent packages

* Mon Jun 13 2005 Paul Howarth <paul@city-fan.org> 4.1.2-1
- Update to 4.1.2
- Add gettext build requirement for translations
- Don't delete user/group torrent on uninstall
  (see https://www.redhat.com/archives/fedora-extras-commits/2005-June/msg00271.html)

* Thu Jun  2 2005 Paul Howarth <paul@city-fan.org> 4.1.1-4
- Further improvements to initscripts (use disown)

* Wed Jun  1 2005 Paul Howarth <paul@city-fan.org> 4.1.1-3
- Tweak btseed defaults so that log file doesn't grow ridiculously quickly

* Wed Jun  1 2005 Paul Howarth <paul@city-fan.org> 4.1.1-2
- Improved initscripts (#158273)
- For versions on anything other than Fedora Core 3, put server data
  under /srv rather than %%{_localstatedir}
- Use %%{find_lang} for translations
- Add Provides: BitTorrent & BitTorrent-gui for clean upgrades

* Wed May 25 2005 Paul Howarth <paul@city-fan.org> 4.1.1-1
- Update to 4.1.1
- Add "khashmir" python library
- Add TRACKERLESS.txt as %%doc
- Add any bittorrent.mo files

* Tue May 24 2005 Paul Howarth <paul@city-fan.org> 4.0.2-1
- Update to 4.0.2

* Mon May 23 2005 Paul Howarth <paul@city-fan.org> 4.0.1-2
- Rename package "bittorrent" for Fedora Extras compatibility
- Properly specify locations of files using python_sitelib macro
- Update download URL
- Add initscripts so users can easily set up trackers and seeders
  on their own (#158273)
- Add user torrent for tracker/seeder
- Add logrotate script for tracker

* Wed Mar 30 2005 Paul Howarth <paul@city-fan.org> 4.0.1-1
- Update to 4.0.1
- PreReq desktop-file-utils >= 0.9 for update-desktop-database for GUI
- bttest.py no longer installed (upstream)
- Update URL
- BuildRequires python-devel, not python

* Wed Mar  9 2005 Paul Howarth <paul@city-fan.org> 4.0.0-1
- Update to 4.0.0

* Mon Jan 31 2005 Paul Howarth <paul@city-fan.org> 3.9.1-1
- Update to 3.9.1
- Remove perl, add sed & desktop-file-utils to BuildRequires
- Separate (optimized) build and install phases
- Add desktop entry

* Thu Dec 23 2004 Paul Howarth <paul@city-fan.org> 3.9.0-1
- Update to 3.9.0
- INSTALL* files no longer present
- License changed to BitTorrent Open Source License
- Source URL changed
- Build process and file list changed due to upstream changes
- "donated" file removed as the nagging now works properly on multi-user systems
- GUI now uses pygtk2 rather than wxPython

* Tue Sep 14 2004 Paul Howarth <paul@city-fan.org> 3.4.2-3
- Create %%{_bindir}/donated to stop donation prompts that can never be
  turned off because users can't write to  %%{_bindir}/donated

* Mon Jul 26 2004 Paul Howarth <paul@city-fan.org> 3.4.2-2
- Fix for wxPython-py2.3 breakage suggested by ZyzX at
  http://www.linuxquestions.org/questions/showthread.php?postid=1026197#post1026197
- Create decent python dependecies

* Fri Apr 16 2004 Paul Howarth <paul@city-fan.org> 3.4.2-1
- Update to 3.4.2.
- Changed distribution-identifying macros for greater portability.

* Sat Mar 13 2004 Paul Howarth <paul@city-fan.org> 3.4.1a-1
- Update to 3.4.1a.

* Fri Mar 12 2004 Paul Howarth <paul@city-fan.org> 3.4.1-2
- Replaced python-2.3 patch with official patch from CVS.

* Fri Mar 12 2004 Paul Howarth <paul@city-fan.org> 3.4.1-1
- Update to 3.4.1.
- Added patch to work around use of python-2.3-only BooleanType.

* Thu Mar 11 2004 Paul Howarth <paul@city-fan.org> 3.4-2
- Use official BitTorrent .zip file as source, since it no longer
  includes the enormous Windows executeable.
- Strip trailing carriage returns out of all files at prep stage.

* Sun Mar 07 2004 Paul Howarth <paul@city-fan.org> 3.4-1.fc1
- Update to 3.4.
- More macros in spec file for portability.
- Get rid of carriage-return characters at end of lines in python scripts.

* Sat Dec 13 2003 Paul Howarth <paul@city-fan.org> 3.3-1.fc1
- Added Fedora Core version into RPM release ID.
- Change Requires: from wxPythonGTK to wxPython for compatibility
  with both wxPythonGTK and wxPythonGTK2.

* Thu Sep 25 2003 Paul Howarth <paul@city-fan.org> 3.3-1
- Update to 3.3.
- Package names changed from bittorrent to BitTorrent in line with
  official naming convention.

* Fri Sep 19 2003 Paul Howarth <paul@city-fan.org> CVS20030911-1
- Update to nicer CVS version.

* Mon May 19 2003 Paul Howarth <paul@city-fan.org> 3.2.1b-1
- Built on Red Hat Linux 9.

* Sun Mar 30 2003 Götz Waschk <waschk@linux-mandrake.com> 3.2.1b-1mdk
- split out gui tools to remove wxPythonGTK dep from the main package 
- new version

* Fri Mar 28 2003 Frederic Lepied <flepied@mandrakesoft.com> 3.2-1mdk
- 3.2

* Wed Mar 26 2003 Frederic Lepied <flepied@mandrakesoft.com> 3.1-1mdk
- initial packaging
